#! /bin/bash

dropRule="-p udp -m udp --sport 53 -m length --length 1500:65535 -j DROP"
insertPrefix="-I INPUT"
dropPrefix="-D INPUT"

namespaceRaw=`grep server-namespace /etc/dnsmasq.conf`
serverNamespace=`echo $namespaceRaw | cut -d'=' -f 2`

namespacePrefix=''

if [ "$serverNamespace" != "default" ];
then
   namespacePrefix="ip netns exec $serverNamespace"
fi

if [ "$1" == "--uninstall" ];
then
   logger -t "SecurityAdvisory0017" "Uninstalling Rule"
   sudo $namespacePrefix iptables $dropPrefix $dropRule
   sudo $namespacePrefix ip6tables $dropPrefix $dropRule
   exit 0
fi


iptablesRules=$(sudo $namespacePrefix iptables-save)
case "$iptablesRules" in
   *"$dropRule"* )
   ;;
   * )
   logger -t "SecurityAdvisory0017" "Rule not found, adding (v4)"
   sudo $namespacePrefix iptables $insertPrefix $dropRule
   logger -t "SecurityAdvisory0017" "Rule added (v4)"
   ;;
esac

ip6tablesRules=$(sudo $namespacePrefix ip6tables-save)
case "$ip6tablesRules" in
   *"$dropRule"* )
   ;;
   * )
   logger -t "SecurityAdvisory0017" "Rule not found, adding (v6)"
   sudo $namespacePrefix ip6tables $insertPrefix $dropRule
   logger -t "SecurityAdvisory0017" "Rule added (v6)"
   ;;
esac
